// EARTH DEFENDER
// By Banjo
// banjosbbs@hotmail.com
// www.banjosbbs.blogspot.com
// Version 0.7
//
// CREDITS:
// Story, Dialog & Characters by Banjo.
// Script Programming by Banjo.
// Alien Ship models by Simon Schild (Simon-3D).
// Ship HUD graphics by Banjo, using Z-Design PS Brushes.
// Hanger graphics based on an image by Richard Tilbury.
// Laser graphics by Ufpelessar.
// Enemy Blast graphics by Kepli.
// Explosion graphics by Lee Gainer.
// Sky and space backgrounds sourced from NASA, stock photos and various free online sources.
// Sound effects by Origin (from the game Wing Commander IV) and Bandai (from the anime Mobile Suit Gundam).
// Music by Konami & Nazo Project (from the Gradius Perfect Selection soundtrack).
//
// COPYRIGHT:
// This script, from http://ss.deviatenow.com, is protected by this licence:
// CC BY-NC-ND, see http://creativecommons.org/licenses/by-nc-nd/4.0/
// This copyright refers only to this script itself; it does not include any other included resources (images, music, sounds, etc.) which remain the property of their owners.
//
// SCRIPT RESOURCES
// This contains a list of files included with the script when published to the SexScripts website
/*
 * Resources
 * scripts/Banjo/earthdefender.groovy
 * run_earthdefender.bat
 */
//

//Metadata
setInfos(7, "Earth Defender",
	"Shooter game (requires Earth Defender Resource Pack)",
	"Banjo",
	"v0.7", 0xFFFFFF, "en",
	["game","formale","forfemale","roleplay","earthdefender"]);

//User Settings
def debug = false
def fullhud = true
def musicOn = true

//Load Saved Settings
def loadSettings = {
	if(loadBoolean("Banjo.earthdefender.custom")) {
		fullhud = loadBoolean("Banjo.earthdefender.fullhud")
		musicOn = loadBoolean("Banjo.earthdefender.musicOn")
		debug = loadBoolean("Banjo.earthdefender.debug")
	}
}

//Help
def version = "Demo Version"
def helpmessage = "For instructions on how to play, click the 'Help' button under the 'Extras' menu."

//System Settings
def quadsArray = ["Alpha","Beta","Gamma","Delta","System"]
def playerSystems = ["Shield Charge","Switch Guns","Afterburner","Missile Launch"]
def playerReaction
def playerShields
def playerPower
def playerSpeed
def playerMissiles
def playerMissilePower
def playerHUD
def playerBoost
def playerMissile
def playerReactor
def playerShieldsLimit
def playerReactorLimit
def playerMissilesLimit
def loseWave
def wave
def waveSize
def waveRemaining
def waveDefeated
def shootQuad
def quadAlpha
def quadBeta
def quadGamma
def quadDelta
def quadCenter
def enemyQuad
def enemyShields
def enemyPower
def enemySpeed
def enemyDodge
def enemyName
def enemyImage
def enemyShootback
def enemyECM
def enemySurvived
def enemyShieldsReduced
def turretShoot
def background
def gameWon
def gameOver
def quit
def mode
def choiceArray
def choice
def choicePick
def timestamp
def reactionLimit
def thrustBonus
def playerKills
def waveBoss
def bigBoss
def difficultyModes = ["Easy","Normal","Hard","Extreme"]
def difficulty
def difficultyReactionBonus
def difficultyEnemyAim
def difficultyPlayerAim
def difficultyPower
def difficultyShields
def difficultyReactor
def difficultyMissiles
def difficultyEnemyPower
def difficultyEnemyShields
def difficultyPlayerSpeed
def difficultyEnemyDodge
def difficultyWaveBonus
def difficultyShootback
def upgradePower
def upgradeShields
def upgradeMissilePower
def upgradeMissileRack
def upgradeReactor
def upgradeAim
def upgradeSpeed
def upgradeThrust
def playerGuns
def hasGunMachinegun
def hasGunLaser
def playerAccel
def warning
def level
def viewIntel
def displayIntel

//Difficulty
def setDifficulty = {
	if(difficulty=="Normal") {
		difficultyReactionBonus = 0
		difficultyEnemyAim = 0
		difficultyPlayerAim = 0
		difficultyPower = 0
		difficultyShields = 0
		difficultyReactor = 0
		difficultyMissiles = 0
		difficultyEnemyPower = 0
		difficultyEnemyShields = 0
		difficultyPlayerSpeed = 0
		difficultyEnemyDodge = 0
		difficultyWaveBonus = 0
		difficultyShootback = 0
	} else if(difficulty=="Easy") {
		difficultyReactionBonus = 0.5
		difficultyEnemyAim = -1
		difficultyPlayerAim = 1
		difficultyPower = 0
		difficultyShields = 2
		difficultyReactor = 2
		difficultyMissiles = 2
		difficultyEnemyPower = 0
		difficultyEnemyShields = 0
		difficultyPlayerSpeed = 0
		difficultyEnemyDodge = 0
		difficultyWaveBonus = -2
		difficultyShootback = -1
	} else if(difficulty=="Hard") {
		difficultyReactionBonus = -0.5
		difficultyEnemyAim = 1
		difficultyPlayerAim = -1
		difficultyPower = 0
		difficultyShields = -1
		difficultyReactor = -1
		difficultyMissiles = -2
		difficultyEnemyPower = 0
		difficultyEnemyShields = 0
		difficultyPlayerSpeed = 0
		difficultyEnemyDodge = 0
		difficultyWaveBonus = 4
		difficultyShootback = 0
	} else if(difficulty=="Extreme") {
		difficultyReactionBonus = -0.5
		difficultyEnemyAim = 2
		difficultyPlayerAim = -1
		difficultyPower = 0
		difficultyShields = -1
		difficultyReactor = -1
		difficultyMissiles = -2
		difficultyEnemyPower = 1
		difficultyEnemyShields = 1
		difficultyPlayerSpeed = 0
		difficultyEnemyDodge = 1
		difficultyWaveBonus = 6
		difficultyShootback = 1
	}
}

def chooseDifficulty = {
	def difficultyPick = getSelectedValue("Select Difficulty Level",difficultyModes)
	difficulty = difficultyModes[difficultyPick]
	setDifficulty()
}

//HUD and Cockpit Views
//Thanks to Liz for help with this code
def setImageCockpit = { picture ->
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+picture)
	def width = image.getWidth()
	def height = image.getHeight()

	def frameBuffer = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def sprite = javax.imageio.ImageIO.read(new File("images/"+picture))
	def hudimage = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_base.png"))
	def hudwidth = hudimage.getWidth()
	def hudheight = hudimage.getHeight()

	java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	graphics.drawImage(sprite,0,0,width,height, null)
	graphics.drawImage(hudimage,0,0,hudwidth,hudheight, null)

	if(fullhud) {
		def hudshields = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_shields-"+playerShields+".png"))
		def hudreactor = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_reactor-"+playerReactor+".png"))
		def hudmissiles = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_missiles-"+playerMissiles+".png"))
		def hudguns = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_guns-"+playerGuns+".png"))
		def hudspeed = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_speed-"+playerAccel+".png"))
		def hudwarning = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_warning-"+warning+".png"))
		graphics.drawImage(hudshields,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudreactor,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudmissiles,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudguns,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudspeed,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudwarning,0,0,hudwidth,hudheight, null)
	}

	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(frameBuffer, "png", baos)
	setImage(baos.toByteArray(),0)
}

def setImageCombat = { xpos, ypos ->
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/earthdefender/"+background+".jpg")
	def width = image.getWidth()
	def height = image.getHeight()
	def oimage = java.awt.Toolkit.getDefaultToolkit().getImage("images/earthdefender/enemy_"+enemyImage+".png")
	def owidth = oimage.getWidth()
	def oheight = oimage.getHeight()

	def frameBuffer = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def sprite = javax.imageio.ImageIO.read(new File("images/earthdefender/"+background+".jpg"))
	def osprite = javax.imageio.ImageIO.read(new File("images/earthdefender/enemy_"+enemyImage+".png"))
	def hudimage = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_base.png"))
	def hudwidth = hudimage.getWidth()
	def hudheight = hudimage.getHeight()

	java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	graphics.drawImage(sprite,0,0,width,height, null)
	graphics.drawImage(osprite,xpos,ypos,owidth,oheight, null)
	graphics.drawImage(hudimage,0,0,hudwidth,hudheight, null)

	if(fullhud) {
		def hudshields = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_shields-"+playerShields+".png"))
		def hudreactor = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_reactor-"+playerReactor+".png"))
		def hudmissiles = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_missiles-"+playerMissiles+".png"))
		def hudguns = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_guns-"+playerGuns+".png"))
		def hudspeed = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_speed-"+playerAccel+".png"))
		def hudwarning = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_warning-"+warning+".png"))
		graphics.drawImage(hudshields,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudreactor,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudmissiles,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudguns,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudspeed,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudwarning,0,0,hudwidth,hudheight, null)
	}

	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(frameBuffer, "png", baos)
	setImage(baos.toByteArray(),0)
}

def setImagePlayerShoot = { fireType, fireFrame ->
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/earthdefender/"+background+".jpg")
	def width = image.getWidth()
	def height = image.getHeight()
	def oimage = java.awt.Toolkit.getDefaultToolkit().getImage("images/earthdefender/enemy_"+enemyImage+".png")
	def owidth = oimage.getWidth()
	def oheight = oimage.getHeight()

	def frameBuffer = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def sprite = javax.imageio.ImageIO.read(new File("images/earthdefender/"+background+".jpg"))
	def osprite = javax.imageio.ImageIO.read(new File("images/earthdefender/enemy_"+enemyImage+".png"))
	def shootsprite = javax.imageio.ImageIO.read(new File("images/earthdefender/fire_"+fireType+""+fireFrame+".png"))
	def hudimage = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_base.png"))
	def hudwidth = hudimage.getWidth()
	def hudheight = hudimage.getHeight()

	java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	graphics.drawImage(sprite,0,0,width,height, null)
	if(enemyQuad=="All")
		graphics.drawImage(osprite,1,1,owidth,oheight, null)
	else
		graphics.drawImage(osprite,160,120,owidth,oheight, null)
	graphics.drawImage(shootsprite,0,0,hudwidth,hudheight, null)
	graphics.drawImage(hudimage,0,0,hudwidth,hudheight, null)

	if(fullhud) {
		def hudshields = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_shields-"+playerShields+".png"))
		def hudreactor = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_reactor-"+playerReactor+".png"))
		def hudmissiles = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_missiles-"+playerMissiles+".png"))
		def hudguns = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_guns-"+playerGuns+".png"))
		def hudspeed = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_speed-"+playerAccel+".png"))
		def hudwarning = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_warning-"+warning+".png"))
		graphics.drawImage(hudshields,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudreactor,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudmissiles,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudguns,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudspeed,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudwarning,0,0,hudwidth,hudheight, null)
	}

	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(frameBuffer, "png", baos)
	setImage(baos.toByteArray(),0)
}

def setImageEnemyShoot = { xpos, ypos, fireFrame ->
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/earthdefender/"+background+".jpg")
	def width = image.getWidth()
	def height = image.getHeight()
	def oimage = java.awt.Toolkit.getDefaultToolkit().getImage("images/earthdefender/enemy_"+enemyImage+".png")
	def owidth = oimage.getWidth()
	def oheight = oimage.getHeight()

	def frameBuffer = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def sprite = javax.imageio.ImageIO.read(new File("images/earthdefender/"+background+".jpg"))
	def osprite = javax.imageio.ImageIO.read(new File("images/earthdefender/enemy_"+enemyImage+".png"))
	def blastsprite = javax.imageio.ImageIO.read(new File("images/earthdefender/enemy_blast"+fireFrame+".png"))
	def hudimage = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_base.png"))
	def hudwidth = hudimage.getWidth()
	def hudheight = hudimage.getHeight()

	java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	graphics.drawImage(sprite,0,0,width,height, null)
	if(enemyQuad=="All")
		graphics.drawImage(osprite,1,1,owidth,oheight, null)
	else
		graphics.drawImage(osprite,xpos,ypos,owidth,oheight, null)
	if(enemyQuad=="All") {
		if(turretShoot==1)
			graphics.drawImage(blastsprite,0,0,320,240, null)
		else if(turretShoot==2)
			graphics.drawImage(blastsprite,320,0,320,240, null)
		else if(turretShoot==3)
			graphics.drawImage(blastsprite,0,240,320,240, null)
		else if(turretShoot==4)
			graphics.drawImage(blastsprite,320,240,320,240, null)
		else if(turretShoot==5)
			graphics.drawImage(blastsprite,160,120,320,240, null)
	} else
		graphics.drawImage(blastsprite,xpos,ypos,owidth,oheight, null)
	graphics.drawImage(hudimage,0,0,hudwidth,hudheight, null)

	if(fullhud) {
		def hudshields = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_shields-"+playerShields+".png"))
		def hudreactor = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_reactor-"+playerReactor+".png"))
		def hudmissiles = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_missiles-"+playerMissiles+".png"))
		def hudguns = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_guns-"+playerGuns+".png"))
		def hudspeed = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_speed-"+playerAccel+".png"))
		def hudwarning = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_warning-"+warning+".png"))
		graphics.drawImage(hudshields,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudreactor,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudmissiles,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudguns,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudspeed,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudwarning,0,0,hudwidth,hudheight, null)
	}

	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(frameBuffer, "png", baos)
	setImage(baos.toByteArray(),0)
}

def setImageEnemyHit = { xpos, ypos ->
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/earthdefender/"+background+".jpg")
	def width = image.getWidth()
	def height = image.getHeight()
	def oimage = java.awt.Toolkit.getDefaultToolkit().getImage("images/earthdefender/enemy_"+enemyImage+".png")
	def owidth = oimage.getWidth()
	def oheight = oimage.getHeight()

	def frameBuffer = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def sprite = javax.imageio.ImageIO.read(new File("images/earthdefender/"+background+".jpg"))
	def osprite = javax.imageio.ImageIO.read(new File("images/earthdefender/enemy_"+enemyImage+".png"))
	def hitsprite = javax.imageio.ImageIO.read(new File("images/earthdefender/enemy_hit.png"))
	if(playerMissile)
		hitsprite = javax.imageio.ImageIO.read(new File("images/earthdefender/enemy_explode.png"))
	def hudimage = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_base.png"))
	def hudwidth = hudimage.getWidth()
	def hudheight = hudimage.getHeight()

	java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	graphics.drawImage(sprite,0,0,width,height, null)
	if(enemyQuad=="All")
		graphics.drawImage(osprite,1,1,owidth,oheight, null)
	else
		graphics.drawImage(osprite,xpos,ypos,owidth,oheight, null)
	if(enemyQuad=="All") {
//		if(shootQuad=="Alpha")
//			graphics.drawImage(hitsprite,0,0,320,240, null)
//		else if(shootQuad=="Beta")
//			graphics.drawImage(hitsprite,320,0,320,240, null)
//		else if(shootQuad=="Gamma")
//			graphics.drawImage(hitsprite,0,240,320,240, null)
//		else if(shootQuad=="Delta")
//			graphics.drawImage(hitsprite,320,240,320,240, null)
//		else if(shootQuad=="Center")
			graphics.drawImage(hitsprite,160,120,320,240, null)
	} else
		graphics.drawImage(hitsprite,xpos,ypos,owidth,oheight, null)
	graphics.drawImage(hudimage,0,0,hudwidth,hudheight, null)

	if(fullhud) {
		def hudshields = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_shields-"+playerShields+".png"))
		def hudreactor = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_reactor-"+playerReactor+".png"))
		def hudmissiles = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_missiles-"+playerMissiles+".png"))
		def hudguns = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_guns-"+playerGuns+".png"))
		def hudspeed = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_speed-"+playerAccel+".png"))
		def hudwarning = javax.imageio.ImageIO.read(new File("images/earthdefender/hud_warning-"+warning+".png"))
		graphics.drawImage(hudshields,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudreactor,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudmissiles,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudguns,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudspeed,0,0,hudwidth,hudheight, null)
		graphics.drawImage(hudwarning,0,0,hudwidth,hudheight, null)
	}

	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(frameBuffer, "png", baos)
	setImage(baos.toByteArray(),0)
}

def setImageIntel = { opicture ->
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/earthdefender/intel_screen.jpg")
	def width = image.getWidth()
	def height = image.getHeight()
	def oimage = java.awt.Toolkit.getDefaultToolkit().getImage("images/earthdefender/intel_"+opicture+".png")
	def owidth = oimage.getWidth()
	def oheight = oimage.getHeight()

	def frameBuffer = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def sprite = javax.imageio.ImageIO.read(new File("images/earthdefender/intel_screen.jpg"))
	def osprite = javax.imageio.ImageIO.read(new File("images/earthdefender/intel_"+opicture+".png"))

	java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	graphics.drawImage(sprite,0,0,width,height, null)
	graphics.drawImage(osprite,0,0,width,height, null)

	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(frameBuffer, "png", baos)
	setImage(baos.toByteArray(),0)
}

//Enemy Appearances
def enemyQuadAlpha = {
	setImageCombat(1,10)
}

def enemyQuadBeta = {
	setImageCombat(320,10)
}

def enemyQuadGamma = {
	setImageCombat(1,240)
}

def enemyQuadDelta = {
	setImageCombat(320,240)
}

def enemyQuadCenter = {
	setImageCombat(160,120)
}

def enemyQuadAll = {
	setImageCombat(1,1)
}

//Enemy Explosions
def explodeQuadAlpha = {
	enemyImage = "explode"
	setImageCombat(1,10)
}

def explodeQuadBeta = {
	enemyImage = "explode"
	setImageCombat(320,10)
}

def explodeQuadGamma = {
	enemyImage = "explode"
	setImageCombat(1,240)
}

def explodeQuadDelta = {
	enemyImage = "explode"
	setImageCombat(320,240)
}

def explodeQuadCenter = {
	enemyImage = "explode"
	setImageCombat(160,120)
}

def explodeQuadAll = {
	enemyImage = "explodebig"
	setImageCombat(1,1)
}

//Enemy Hits
def hitQuadAlpha = {
	setImageEnemyHit(1,10)
}

def hitQuadBeta = {
	setImageEnemyHit(320,10)
}

def hitQuadGamma = {
	setImageEnemyHit(1,240)
}

def hitQuadDelta = {
	setImageEnemyHit(320,240)
}

def hitQuadCenter = {
	setImageEnemyHit(160,120)
}

def hitQuadRandom = {
	def randomHit = getRandom(5)+1
	if(randomHit==1)
		hitQuadAlpha()
	else if(randomHit==2)
		hitQuadBeta()
	else if(randomHit==3)
		hitQuadGamma()
	else if(randomHit==4)
		hitQuadDelta()
	else if(randomHit==5)
		hitQuadCenter()
}

//Ship displays hanger
def setImageHanger = {
	setImageCockpit("earthdefender/hanger.jpg")
}

//Ship displays static
def setImageStatic = {
	staticLength ->
	while(staticLength>0) {
		setImageCockpit("earthdefender/static1.jpg")
		wait(0.05)
		setImageCockpit("earthdefender/static2.jpg")
		wait(0.05)
		setImageCockpit("earthdefender/static3.jpg")
		wait(0.05)
		setImageCockpit("earthdefender/static4.jpg")
		wait(0.05)
		staticLength --
	}
}

//Enemy Gun SFX
def playSoundEnemyShoot = {
	playBackgroundSound("banjo/earthdefender/enemy_shoot.mp3")
	if(enemyQuad=="Alpha") {
		setImageEnemyShoot(1,10,"1")
		setImageEnemyShoot(1,10,"2")
		setImageEnemyShoot(1,10,"3")
	} else if(enemyQuad=="Beta") {
		setImageEnemyShoot(320,10,"1")
		setImageEnemyShoot(320,10,"2")
		setImageEnemyShoot(320,10,"3")
	} else if(enemyQuad=="Gamma") {
		setImageEnemyShoot(1,240,"1")
		setImageEnemyShoot(1,240,"2")
		setImageEnemyShoot(1,240,"3")
	} else if(enemyQuad=="Delta") {
		setImageEnemyShoot(320,240,"1")
		setImageEnemyShoot(320,240,"2")
		setImageEnemyShoot(320,240,"3")
	} else if(enemyQuad=="Center") {
		setImageEnemyShoot(160,120,"1")
		setImageEnemyShoot(160,120,"2")
		setImageEnemyShoot(160,120,"3")
	} else if(enemyQuad=="All") {
		turretShoot = getRandom(5)+1
		setImageEnemyShoot(320,240,"1")
		setImageEnemyShoot(320,240,"2")
		setImageEnemyShoot(320,240,"3")
	}
}

def playSoundPlayerShoot = {
	if(playerGuns=="machinegun") {
		playBackgroundSound("banjo/earthdefender/player_machinegun.mp3")
		setImagePlayerShoot("machinegun","1")
		setImagePlayerShoot("machinegun","2")
		setImagePlayerShoot("machinegun","3")
		setImagePlayerShoot("machinegun","4")
	} else if(playerGuns=="laser") {
		playBackgroundSound("banjo/earthdefender/player_laser.mp3")
		setImagePlayerShoot("laser","1")
		setImagePlayerShoot("laser","2")
	} else {
		playBackgroundSound("banjo/earthdefender/player_laser.mp3")
		setImagePlayerShoot("laser","1")
		setImagePlayerShoot("laser","2")
	}
}


//Enemy Types (Difficulty Adjusted)
def enemyFighter = {
	enemyName = "Fighter"
	enemyImage = "fighter"
	enemyPower = 1 + difficultyEnemyPower
	enemyShields = 1 + difficultyEnemyShields
	enemyDodge = 0
	enemySpeed = 2
	enemyShootback = 0
	enemyECM = false
}

def enemyScout = {
	enemyName = "Scout"
	enemyImage = "scout"
	enemyPower = 1 + difficultyEnemyPower
	enemyShields = 1 + difficultyEnemyShields
	enemyDodge = 1
	enemySpeed = 1.75
	enemyShootback = 0
	enemyECM = false
}

def enemyBomber = {
	enemyName = "Bomber"
	enemyImage = "bomber"
	enemyPower = 2 + difficultyEnemyPower
	enemyShields = 1 + difficultyEnemyShields
	enemyDodge = -1
	enemySpeed = 2.25
	enemyShootback = 1
	enemyECM = false
}

def enemyAceFighter = {
	enemyName = "Elite"
	enemyImage = "acefighter"
	enemyPower = 2 + difficultyEnemyPower
	enemyShields = 10 + difficultyEnemyShields
	enemyDodge = 1
	enemySpeed = 1.75
	enemyShootback = 1
	enemyECM = true
}

def enemyMothership = {
	enemyName = "Mothership"
	enemyImage = "mothership"
	enemyPower = 1 + difficultyEnemyPower
	enemyShields = 50 + difficultyEnemyShields
	enemyDodge = -2
	enemySpeed = 2
	enemyShootback = 2
	enemyECM = false
	bigBoss = true
}

//Enemy Types (No Adjustments)
def enemyFighterRaw = {
	enemyName = "Fighter"
	enemyImage = "fighter"
	enemyPower = 1
	enemyShields = 1
	enemyDodge = 0
	enemySpeed = 2
	enemyShootback = 0
	enemyECM = false
}

def enemyScoutRaw = {
	enemyName = "Scout"
	enemyImage = "scout"
	enemyPower = 1
	enemyShields = 1
	enemyDodge = 1
	enemySpeed = 1.75
	enemyShootback = 0
	enemyECM = false
}

def enemyBomberRaw = {
	enemyName = "Bomber"
	enemyImage = "bomber"
	enemyPower = 2
	enemyShields = 1
	enemyDodge = -1
	enemySpeed = 2.25
	enemyShootback = 1
	enemyECM = false
}

def enemyAceFighterRaw = {
	enemyName = "Elite"
	enemyImage = "acefighter"
	enemyPower = 2
	enemyShields = 10
	enemyDodge = 1
	enemySpeed = 1.75
	enemyShootback = 1
	enemyECM = true
}

def enemyMothershipRaw = {
	enemyName = "Mothership"
	enemyImage = "mothership"
	enemyPower = 1
	enemyShields = 50
	enemyDodge = -2
	enemySpeed = 2
	enemyShootback = 2
	enemyECM = false
	bigBoss = true
}

//Kill Enemy
def killEnemy = {
	enemySurvived = false
	if(enemyQuad=="Alpha")
		explodeQuadAlpha()
	else if(enemyQuad=="Beta")
		explodeQuadBeta()
	else if(enemyQuad=="Gamma")
		explodeQuadGamma()
	else if(enemyQuad=="Delta")
		explodeQuadDelta()
	if(enemyQuad=="Center")
		explodeQuadCenter()
	else if(enemyQuad=="All")
		explodeQuadAll()
	playerKills ++
	playSound("banjo/earthdefender/enemy_explode.mp3")
	setImageCockpit("earthdefender/"+background+".jpg")
	waveRemaining --
	waveDefeated ++
	if(debug) {
		show("Enemies defeated this wave: "+waveDefeated+"")
		wait(0.5)
	}
}

def hitQuad = {
	if(enemyQuad=="Alpha")
		hitQuadAlpha()
	else if(enemyQuad=="Beta")
		hitQuadBeta()
	else if(enemyQuad=="Gamma")
		hitQuadGamma()
	else if(enemyQuad=="Delta")
		hitQuadDelta()
	else if(enemyQuad=="Center")
		hitQuadCenter()
	else if(enemyQuad=="All")
		hitQuadRandom()
}

//Play Music
def playMusic = {
	track ->
	if(musicOn) {
		playBackgroundSound(null)
		playBackgroundSound("banjo/earthdefender/music_"+track+".mp3",9999)
	}
}

def stopMusic = {
	playBackgroundSound(null)
}

//Player HUD
def updatePlayer = {
	if(!fullhud) {
		playerHUD = "SHIP STATUS:\nShields [ "+playerShields+" ]\nReactor [ "+playerReactor+" ]\nMissiles [ "+playerMissiles+" ]\n"
	} else {
		playerHUD = ""	
	}
}

//Rearm, Recharge and Refuel Player
def rechargePlayer = {
	playerShields = playerShieldsLimit
}

def refuelPlayer = {
	playerReactor = playerReactorLimit
}

def rearmPlayer = {
	playerMissiles = playerMissilesLimit
}

def restockPlayer = {
	rechargePlayer()
	refuelPlayer()
	rearmPlayer()
}

//Upgrade Player
def upgradeGunsBasic = {
	playerGuns = "laser"
	upgradePower = 0
	upgradeAim = 0
	playerPower = 1 + upgradePower + difficultyPower
}

def upgradeGunsMachinegun = {
	playerGuns = "machinegun"
	upgradePower = 1
	upgradeAim = 0
	playerPower = 1 + upgradePower + difficultyPower
}

def upgradeGunsLaser = {
	playerGuns = "laser"
	upgradePower = 0
	upgradeAim = 1
	playerPower = 1 + upgradePower + difficultyPower
}

def upgradeDemo = {
	upgradeGunsLaser()
	hasGunMachinegun = true
	hasGunLaser = true
}

def upgradeNone = {
	upgradePower = 0
	upgradeShields = 0
	upgradeMissilePower = 0
	upgradeMissileRack = 0
	upgradeReactor = 0
	upgradeAim = 0
	upgradeSpeed = 0
	upgradeThrust = 0
	upgradeGunsBasic()
	hasGunMachinegun = false
	hasGunLaser = false
}

//Load Player
def loadPlayer = {
	playerPower = 1 + upgradePower + difficultyPower
	playerShieldsLimit = 4 + upgradeShields + difficultyShields
	playerReactorLimit = 4 + upgradeReactor + difficultyReactor
	playerMissilesLimit = 4 + upgradeMissileRack + difficultyMissiles
	playerShields = playerShieldsLimit
	playerReactor = playerReactorLimit
	playerMissiles = playerMissilesLimit
	playerSpeed = 2 + upgradeSpeed + difficultyPlayerSpeed
	playerMissilePower = 10 + upgradeMissilePower
	thrustBonus = 2 + upgradeThrust
	playerAccel = 0
	updatePlayer()
}

//Kill Player
def killPlayer = {
	playBackgroundSound(null)
	playerAccel = 0
	show(""+playerHUD+"\n\n\n\nPilot Unsynchronised")
	playBackgroundSound("banjo/earthdefender/sync_error.mp3")
	setImageStatic(1)
	loseWave = true
	wave = false
	gameWon = false
	gameOver = true
}

//Combat Engine
def showQuad = {
	quad ->
	if(quad=="Alpha")
		enemyQuadAlpha()
	else if(quad=="Beta")
		enemyQuadBeta()
	else if(quad=="Gamma")
		enemyQuadGamma()
	else if(quad=="Delta")
		enemyQuadDelta()
	else if(quad=="Center")
		enemyQuadCenter()
	else if(quad=="All")
		enemyQuadAll()
}

def loadQuad = {
	if(bigBoss) {
		enemyQuad = "All"
	} else {
		def enemyQuadPick = getRandom(4)+1
		if(enemyQuadPick==1)
			enemyQuad = "Alpha"
		else if(enemyQuadPick==2)
			enemyQuad = "Beta"
		else if(enemyQuadPick==3)
			enemyQuad = "Gamma"
		else if(enemyQuadPick==4)
			enemyQuad = "Delta"
//		else if(enemyQuadPick==5)
//			enemyQuad = "Center"
	}
	showQuad(enemyQuad)
}

def loadEnemy = {
	enemyType ->
	if(enemySurvived) {
		enemyType = enemyImage
	}
	def pickEnemy
	if(enemyType=="fighter")
		enemyFighter()
	else if(enemyType=="scout")
		enemyScout()
	else if(enemyType=="bomber")
		enemyBomber()
	else if(enemyType=="acefighter")
		enemyAceFighter()
	else if(enemyType=="mothership")
		enemyMothership()
	else if(enemyType=="fighter_scout") {
		pickEnemy = getRandom(2)+1
		if(pickEnemy==1)
			enemyFighter()
		else if(pickEnemy==2)
			enemyScout()
	} else if(enemyType=="fighter_bomber") {
		pickEnemy = getRandom(2)+1
		if(pickEnemy==1)
			enemyFighter()
		else if(pickEnemy==2)
			enemyBomber()
	} else if(enemyType=="fleet") {
		pickEnemy = getRandom(4)+1
		if(pickEnemy<=2)
			enemyFighter()
		else if(pickEnemy==3)
			enemyScout()
		else if(pickEnemy==4)
			enemyBomber()
	}
	if(enemySurvived) {
		enemyShields = enemyShieldsReduced
	}
}

def loadEnemyRaw = {
	enemyType ->
	if(enemyType=="fighter")
		enemyFighterRaw()
	else if(enemyType=="scout")
		enemyScoutRaw()
	else if(enemyType=="bomber")
		enemyBomberRaw()
	else if(enemyType=="acefighter")
		enemyAceFighterRaw()
	else if(enemyType=="mothership")
		enemyMothershipRaw()
}

def shootPlayer = {
	enemyAimModifier ->
	warning = "enemylock"
	showQuad(enemyQuad)
	if(!fullhud)
		show(""+playerHUD+"\n\n\n\nIncoming fire!")
	if(playerBoost>0) {
		playerSpeed = playerSpeed + thrustBonus
	}
	def enemyAim = (getRandom(10)+1) - enemyAimModifier - difficultyEnemyAim + playerSpeed
	playSoundEnemyShoot()
	if(enemyAim<=6) {
		playerShields = playerShields - enemyPower
		if(playerShields<0)
			playerShields = 0
		updatePlayer()
//		if(!fullhud)
			show(""+playerHUD+"\n\n\n\nYou've been hit!")
		playSound("banjo/earthdefender/player_hit.mp3")
	} else {
//		if(!fullhud)
			show(""+playerHUD+"\n\n\n\nEnemy missed!")
		wait(1)
	}
	warning = "none"
	showQuad(enemyQuad)
	if(playerBoost>0) {
		playerSpeed = playerSpeed - thrustBonus
	}
	if(playerShields<=0) {
		killPlayer()
	}
}

def shootbackEnemy = {
	shootbackModifier ->
	def enemyReturnFire = (getRandom(10)+1) + enemyShootback + shootbackModifier + difficultyShootback
	if(enemyReturnFire>=7)
		shootPlayer(-1)
}

def shootEnemy = {
	playerAimModifier ->
	def missed = false
	def playerAim = (getRandom(10)+1) - playerAimModifier - upgradeAim + enemyDodge - difficultyPlayerAim + difficultyEnemyDodge
	if(playerMissile) {
		if(!enemyECM) {
			enemyShields = enemyShields - playerMissilePower
			warning = "targethit"
			if(!fullhud)
				show(""+playerHUD+"\n\n\n\nEnemy hit!")
		} else {
			warning = "locklost"
			showQuad(enemyQuad)
//			if(!fullhud)
				show(""+playerHUD+"\n\n\n\nEnemy released ECM!")
			playSound("banjo/earthdefender/enemy_ecm.mp3")
			missed = true
		}
	} else if(playerAim<=6) {
		enemyShields = enemyShields - playerPower
		warning = "targethit"
		if(!fullhud)
			show(""+playerHUD+"\n\n\n\nEnemy hit!")
	} else {
		warning = "locklost"
		showQuad(enemyQuad)
//		if(!fullhud)
			show(""+playerHUD+"\n\n\n\nYou missed!")
		wait(0.5)
		missed = true
		shootbackEnemy(0)
	}
	if(enemyShields<=0) {
		killEnemy()
	} else if(!missed){
		playBackgroundSound("banjo/earthdefender/enemy_hit.mp3")
		enemySurvived = true
		enemyShieldsReduced = enemyShields
		hitQuad()
		wait(0.25)
		showQuad(enemyQuad)
		shootbackEnemy(-1)
	}
	if(playerMissile) {
		playerMissile = false
	}
	updatePlayer()
	missed = null
}

def fightWave = {
	number, field, enemies, type ->
	background = field
	waveRemaining = enemies
	waveDefeated = 0
	wave = true
	warning = "none"
	playerBoost = 0
	if(!waveBoss) {
		show(""+playerHUD+"\n\n\nWave "+number+"\nGet Ready!")
		playSound("banjo/earthdefender/player_beep.mp3")
	} else {
		loadEnemy(type)
		show(""+playerHUD+"\n\n\nEnemy "+enemyName+" approaching!\nGet Ready!")
		playSound("banjo/earthdefender/player_beep.mp3")
		playSound("banjo/earthdefender/player_warning.mp3")
	}
	wait(1)
	while(wave && !gameOver) {
		while(waveRemaining>0 && !loseWave) {
			if(playerBoost>0) {
				playerAccel = 3
				playerBoost --
			} else {
				playerAccel = 2
			}
			warning = "none"
			loadEnemy(type)
			loadQuad()
			playBackgroundSound("banjo/earthdefender/player_lockon.mp3")
			timestamp = new Date().getTime()
			def shoot = getSelectedValue(""+playerHUD+"\n\n\n\nInput Action",quadsArray)
			if(fullhud)
				show(null)
			shootQuad = quadsArray[shoot]
			playerReaction = new Date().getTime() - timestamp
			playerReaction = playerReaction / 1000
			reactionLimit = enemySpeed + difficultyReactionBonus
			if(debug) {
				show("Reaction Speed: "+playerReaction+".")
				wait(0.5)
			}
			if(shootQuad==enemyQuad && playerReaction<=reactionLimit) {
				playBackgroundSound("banjo/earthdefender/player_locktarget.mp3")
				enemyQuad = "Center"
				warning = "targetlock"
				showQuad(enemyQuad)
				playSoundPlayerShoot()
				shootEnemy(0)
			} else if(shootQuad==enemyQuad && playerReaction>reactionLimit) {
				show(""+playerHUD+"\n\n\n\nToo slow!")
				playSound("banjo/earthdefender/player_error.mp3")
				shootPlayer(0)
			} else if(shootQuad=="System") {
				def systemControlPick = getSelectedValue(""+playerHUD+"\n\n\n\nEngage Which System?",playerSystems)
				def systemControl = playerSystems[systemControlPick]
				if(fullhud)
					show(null)
				if(systemControl=="Missile Launch" && playerMissiles>0) {
					if(playerReaction<=reactionLimit) {
						playerMissile = true
						playerMissiles --
						updatePlayer()
						if(enemyQuad!="All")
							enemyQuad = "Center"
						playBackgroundSound("banjo/earthdefender/player_missilelock.mp3")
						warning = "missilelock"
						showQuad(enemyQuad)
						if(!fullhud)
							show(""+playerHUD+"\n\n\n\nMissile Launched.")
						playSound("banjo/earthdefender/player_missile.mp3")
						shootEnemy(0)
					} else {
						show(""+playerHUD+"\n\n\n\nToo slow!")
						playSound("banjo/earthdefender/player_error.mp3")
						shootPlayer(0)
					}
				} else if(systemControl=="Missile Launch" && playerMissiles<=0) {
					warning = "nomissiles"
					if(!fullhud)
						show(""+playerHUD+"\n\n\n\nOut of Missiles!")
					showQuad(enemyQuad)
					playSound("banjo/earthdefender/player_warning.mp3")
					shootPlayer(1)
				} else if(systemControl=="Switch Guns") {
					if(playerReaction<=reactionLimit) {
						if(playerGuns=="laser" && hasGunMachinegun) {
							upgradeGunsMachinegun()
							showQuad(enemyQuad)
							if(!fullhud)
								show(""+playerHUD+"\n\n\n\nSwitched to Machinegun.")
						} else if(playerGuns=="machinegun" && hasGunLaser) {
							upgradeGunsLaser()
							showQuad(enemyQuad)
							if(!fullhud)
								show(""+playerHUD+"\n\n\n\nSwitched to Laser.")
						}
						playSound("banjo/earthdefender/player_reload.mp3")
						shootPlayer(0)
					} else {
						show(""+playerHUD+"\n\n\n\nToo slow!")
						playSound("banjo/earthdefender/player_error.mp3")
						shootPlayer(0)
					}
				} else if(systemControl=="Shield Charge" && playerReactor>0) {
					if(playerReaction<=reactionLimit) {
						playerShields = playerShields + 2
						if(playerShields>playerShieldsLimit)
							playerShields = playerShieldsLimit
						playerReactor --
						if(!fullhud)
							show(""+playerHUD+"\n\n\n\nShields Charging...")
						playSound("banjo/earthdefender/player_charge.mp3")
						updatePlayer()
						showQuad(enemyQuad)
						shootPlayer(0)
					} else {
						show(""+playerHUD+"\n\n\n\nToo slow!")
						playSound("banjo/earthdefender/player_error.mp3")
						shootPlayer(0)
					}
				} else if(systemControl=="Afterburner" && playerReactor>0) {
					if(playerReaction<=reactionLimit) {
						playerReactor --
						playerBoost = 2
						playerAccel = 3
						if(!fullhud)
							show(""+playerHUD+"\n\n\n\nThrusters Engaged.")
						showQuad(enemyQuad)
						playSound("banjo/earthdefender/player_thrusters.mp3")
						updatePlayer()
						shootPlayer(-1)
					} else {
						show(""+playerHUD+"\n\n\n\nToo slow!")
						playSound("banjo/earthdefender/player_error.mp3")
						shootPlayer(0)
					}
				} else {

					warning = "nopower"
					if(!fullhud)
						show(""+playerHUD+"\n\n\n\nInsufficient Reactor Power!")
					showQuad(enemyQuad)
					playSound("banjo/earthdefender/player_warning.mp3")
					shootPlayer(1)
				}
			} else if(enemyQuad=="All" && playerReaction<=reactionLimit) {
				playBackgroundSound("banjo/earthdefender/player_locktarget.mp3")
				warning = "targetlock"
				showQuad(enemyQuad)
				playSoundPlayerShoot()
				shootEnemy(0)
			} else if(enemyQuad=="All" && playerReaction>reactionLimit) {
				show(""+playerHUD+"\n\n\n\nToo slow!")
				playSound("banjo/earthdefender/player_error.mp3")
				shootPlayer(0)
			} else {
				warning = "locklost"
				if(!fullhud)
					show(""+playerHUD+"\n\n\n\nLockon Failed")
				showQuad(enemyQuad)
				playSound("banjo/earthdefender/player_error.mp3")
				shootPlayer(1)
			}
		}
		wave = false
	}
	if(!loseWave) {
		show(""+playerHUD+"\n\n\nWave defeated!\nEnemies Shot Down: "+playerKills+"")
		wait(2)
	}
}

//Cutscenes
def cutsceneLaunch = {
	launchLocation ->
	def bay = "-sky"
	if(launchLocation=="space")
		bay = "-space"
	show(null)
	playerAccel = 0
	warning = "none"
	playBackgroundSound("banjo/earthdefender/player_alarm.mp3")
//	warning = "syncyes"
//	show(""+playerHUD+"\n\n\n\nPilot Synchronised.")
	playBackgroundSound("banjo/earthdefender/sync_process.mp3")
	setImageStatic(1)
	playSound("banjo/earthdefender/sync_beep.mp3")
	if(!fullhud)
		show(""+playerHUD+"\n\n\n\nShip Systems On Line.")
	warning = "systemson"
	setImageCockpit("earthdefender/hanger.jpg")
	wait(1)
	if(!fullhud)
		show(""+playerHUD+"\n\n\n\nPrepare for Launch...")
	warning = "none"
	playBackgroundSound("banjo/earthdefender/player_launch.mp3")
	wait(4.15)
	setImageCockpit("earthdefender/hanger"+bay+"_open1.jpg")
	wait(0.25)
	setImageCockpit("earthdefender/hanger"+bay+"_open2.jpg")
	wait(0.25)
	setImageCockpit("earthdefender/hanger"+bay+"_launch.jpg")
	wait(3)
	playBackgroundSound("banjo/earthdefender/player_thrusters.mp3")
	wait(1)
	playerAccel = 1
	setImageCockpit("earthdefender/hanger"+bay+"_launch1.jpg")
	wait(0.15)
	playerAccel = 2
	setImageCockpit("earthdefender/hanger"+bay+"_launch2.jpg")
	wait(0.15)
	playerAccel = 3
	setImageCockpit("earthdefender/hanger"+bay+"_launch3.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/sky-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/sky.jpg")
	wait(0.15)
	playerAccel = 2
	setImageCockpit("earthdefender/sky.jpg")
	wait(2)
}

def cutsceneDestroyed = {
	playerAccel = 0
	warning = "none"
	playBackgroundSound("banjo/earthdefender/player_explode.mp3")
	wait(0.5)
	setImage("earthdefender/player_explode.jpg")
	show("Your ship has been destroyed!\n\nEnemies Shot Down: "+playerKills+"")
	playBackgroundSound("banjo/earthdefender/fanfare_defeat.mp3")
}

def cutsceneVictory = {
	warning = "none"
	setImageStatic(1)
	setImageHanger()
	show("Congratulations!\n\nYou have defended the earth!\n\nEnemies Shot Down: "+playerKills+"")
	playSound("banjo/earthdefender/fanfare_victory.mp3")
}

def cutsceneRestockAir = {
	warning = "none"
	playerAccel = 2
	setImageCockpit("earthdefender/sky.jpg")
	show(""+playerHUD+"\n\n\n\nRearming and refueling...")
	playSound("banjo/earthdefender/player_warning.mp3")
	playerAccel = 1
	wait(1)
	setImageCockpit("earthdefender/refuel_ready.jpg")
	wait(2)
	playBackgroundSound("banjo/earthdefender/player_restock.mp3")
	wait(1)
	setImageCockpit("earthdefender/refuel_dock.jpg")
	playSound("banjo/earthdefender/player_reload.mp3")
	restockPlayer()
	updatePlayer()
	playSound("banjo/earthdefender/player_charge.mp3")
	wait(1)
	show(""+playerHUD+"\n\n\n\nRearm and refuel complete.")
	playBackgroundSound("banjo/earthdefender/player_restock.mp3")
	wait(2)
	playerAccel = 2
	setImageCockpit("earthdefender/refuel_ready.jpg")
	wait(1)
	playerAccel = 3
	playBackgroundSound("banjo/earthdefender/player_thrusters.mp3")
	wait(0.15)
	setImageCockpit("earthdefender/refuel_ready-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/sky-blur.jpg")
	wait(0.5)
	playerAccel = 2
	setImageCockpit("earthdefender/sky.jpg")
	wait(2)
}

def cutsceneRestockSpace = {
	warning = "none"
	playerAccel = 2
	setImageCockpit("earthdefender/orbit.jpg")
	show(""+playerHUD+"\n\n\n\nRearming and refueling...")
	playSound("banjo/earthdefender/player_warning.mp3")
	playerAccel = 1
	wait(1)
	setImageCockpit("earthdefender/station.jpg")
	wait(2)
	playBackgroundSound("banjo/earthdefender/player_restock.mp3")
	wait(1)
	playerAccel = 0
	setImageCockpit("earthdefender/station_dock.jpg")
	playSound("banjo/earthdefender/player_reload.mp3")
	restockPlayer()
	updatePlayer()
	playSound("banjo/earthdefender/player_charge.mp3")
	wait(1)
	show(""+playerHUD+"\n\n\n\nRearm and refuel complete.")
	playBackgroundSound("banjo/earthdefender/player_restock.mp3")
	wait(2)
	playerAccel = 1
	setImageCockpit("earthdefender/station.jpg")
	wait(1)
	playerAccel = 3
	playBackgroundSound("banjo/earthdefender/player_thrusters.mp3")
	wait(0.15)
	setImageCockpit("earthdefender/station-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/orbit-blur.jpg")
	wait(0.5)
	playerAccel = 2
	setImageCockpit("earthdefender/orbit.jpg")
	wait(2)
}

def cutsceneBreakAtmos = {
	warning = "none"
	playerAccel = 2
	setImageCockpit("earthdefender/sky.jpg")
	show(""+playerHUD+"\n\n\n\nLeaving atmosphere...")
	playSound("banjo/earthdefender/player_warning.mp3")
	playerAccel = 3
	playBackgroundSound("banjo/earthdefender/player_thrusters.mp3")
	setImageCockpit("earthdefender/sky-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/atmos-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/atmos.jpg")
	wait(0.15)
	playerAccel = 2
	setImageCockpit("earthdefender/orbit.jpg")
	show(""+playerHUD+"\n\n\n\nOrbit achieved.")
	playSound("banjo/earthdefender/player_beep.mp3")
	wait(1)
	playerAccel = 2
}

def cutsceneBreakOrbit = {
	warning = "none"
	playerAccel = 2
	setImageCockpit("earthdefender/orbit.jpg")
	show(""+playerHUD+"\n\n\n\nLeaving orbit...")
	playSound("banjo/earthdefender/player_warning.mp3")
	playerAccel = 3
	playBackgroundSound("banjo/earthdefender/player_thrusters.mp3")
	setImageCockpit("earthdefender/orbit-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/space-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/space.jpg")
	wait(0.15)
	playerAccel = 2
	setImageCockpit("earthdefender/space.jpg")
	show(""+playerHUD+"\n\n\n\nEscape velocity achieved.")
	playSound("banjo/earthdefender/player_beep.mp3")
	wait(1)
	playerAccel = 2
}

def cutsceneThrustSky = {
	playerAccel = 3
	playBackgroundSound("banjo/earthdefender/player_thrusters.mp3")
	setImageCockpit("earthdefender/sky.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/sky-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/sky.jpg")
	wait(0.15)
	playerAccel = 2
	setImageCockpit("earthdefender/sky.jpg")
}

def cutsceneThrustOrbit = {
	playerAccel = 3
	playBackgroundSound("banjo/earthdefender/player_thrusters.mp3")
	setImageCockpit("earthdefender/orbit.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/orbit-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/orbit.jpg")
	wait(0.15)
	playerAccel = 2
	setImageCockpit("earthdefender/orbit.jpg")
}

def cutsceneThrustMoon = {
	playerAccel = 3
	playBackgroundSound("banjo/earthdefender/player_thrusters.mp3")
	setImageCockpit("earthdefender/orbit_moon.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/orbit_moon-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/orbit-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/orbit.jpg")
	wait(0.15)
	playerAccel = 2
	setImageCockpit("earthdefender/orbit.jpg")
}

def cutsceneThrustSpace = {
	playerAccel = 3
	playBackgroundSound("banjo/earthdefender/player_thrusters.mp3")
	setImageCockpit("earthdefender/space.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/space-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/space.jpg")
	wait(0.15)
	playerAccel = 2
	setImageCockpit("earthdefender/space.jpg")
}

def cutsceneThrustFleet = {
	playerAccel = 3
	playBackgroundSound("banjo/earthdefender/player_thrusters.mp3")
	setImageCockpit("earthdefender/space.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/space-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/space_fleet-blur.jpg")
	wait(0.15)
	setImageCockpit("earthdefender/space_fleet.jpg")
	wait(0.15)
	playerAccel = 2
	setImageCockpit("earthdefender/space_fleet.jpg")
}

def menuMusic = {
	playBackgroundSound(null)
	playMusic("01")
}

def pressStart = {
	playBackgroundSound(null)
	playBackgroundSound("banjo/earthdefender/fanfare_start.mp3")
	show(null)
	wait(1)
}

//Arcade Mode
def arcadeLevel1 = {
	level = 1
	if(!gameOver)
		playMusic("01")
	if(!gameOver)
		fightWave(1,"sky",waveSize,"fighter")
	if(!gameOver)
		cutsceneThrustSky()
	if(!gameOver)
		fightWave(2,"sky",waveSize,"fighter_scout")
}

def arcadeLevel2 = {
	level = 2
	if(!gameOver)
		playMusic("02")
	if(!gameOver)
		fightWave(3,"sky",waveSize,"fighter")
	if(!gameOver)
		cutsceneThrustSky()
	if(!gameOver)
		fightWave(4,"sky",waveSize,"fighter_bomber")
}

def arcadeLevel3 = {
	level = 3
	if(!gameOver) {
		stopMusic()
		cutsceneBreakAtmos()
	}
	if(!gameOver)
		playMusic("03")
	if(!gameOver)
		fightWave(5,"orbit_moon",waveSize,"fighter_bomber")
	if(!gameOver)
		cutsceneThrustMoon()
	if(!gameOver)
		fightWave(6,"orbit",waveSize,"fighter")
}

def arcadeLevel4 = {
	level = 4
	if(!gameOver) {
		stopMusic()
		cutsceneBreakOrbit()
	}
	if(!gameOver)
		playMusic("04")
	if(!gameOver)
		fightWave(7,"space",waveSize+2,"fighter_scout")
	if(!gameOver)
		cutsceneThrustFleet()
	if(!gameOver)
		fightWave(8,"space_fleet",waveSize+2,"fleet")
	if(!gameOver)
		fightWave(9,"space_fleet",waveSize+4,"fleet")
}

def arcadeLevel5 = {
	level = 5
	if(!gameOver) {
		playMusic("05")
		waveBoss = true
		bigBoss = true
		fightWave("Boss","space",1,"mothership")
		bigBoss = false
		waveBoss = false
		if(!loseWave)
			gameWon = true
	}
}

def arcadeLevel0 = {
	level = 0
	if(!gameOver) {
		playMusic("05")
		waveBoss = true
		bigBoss = false
		fightWave("Boss","sky",1,"acefighter")
		bigBoss = false
		waveBoss = false
	}
}

def arcadeMode = {
	chooseDifficulty()
	playerKills = 0
	upgradeNone()
	upgradeDemo()
	loadPlayer()
	gameWon = false
	gameOver = false
	cutsceneLaunch("sky")
	playerAccel = 2
	while(!gameOver) {
		waveSize = 6 + difficultyWaveBonus
		arcadeLevel1()
		if(!gameOver) {
			stopMusic()
			cutsceneRestockAir()
		}
		arcadeLevel2()
		if(!gameOver) {
			stopMusic()
			cutsceneRestockAir()
		}
		arcadeLevel0()
		if(!gameOver) {
			stopMusic()
			cutsceneRestockAir()
		}
		arcadeLevel3()
		if(!gameOver) {
			stopMusic()
			cutsceneRestockSpace()
		}
		arcadeLevel4()
		arcadeLevel5()
		gameOver = true
	}
	playBackgroundSound(null)
	if(gameWon) {
		cutsceneVictory()
		showButton("Back to Menu")
		playBackgroundSound(null)
		menuMusic()
	} else {
		cutsceneDestroyed()
		showButton("Back to Menu")
		menuMusic()
	}
}

//Extras Menu
def intelShow = {
	intelSelected ->
	loadEnemyRaw(intelSelected)
	playBackgroundSound("banjo/earthdefender/player_beep.mp3")
	setImageIntel(enemyImage)
	def enemyECMyesno
		if(enemyECM)
			enemyECMyesno = "Yes"
		else
			enemyECMyesno = "No"
	displayIntel = (""+viewIntel+"\n\n"+
		"Power Rating: "+enemyPower+"\n"+
		"Shields Rating: "+enemyShields+"\n"+
		"Speed Rating: "+enemySpeed+"\n"+
		"Maneuver Rating: "+enemyDodge+"\n"+
		"Reaction Rating: "+enemyShootback+"\n"+
		"ECM Equipped: "+enemyECMyesno+"\n")
}

def intelView = {
	def intelArray = ["Back","Alien Fighter","Alien Scout","Alien Bomber","Alien Elite","Alien Mothership"]
	def intelMenu = true
	setImage("earthdefender/intel_screen.jpg")
	displayIntel = "Select Intel:"
	while(intelMenu) {
		def viewIntelPick = getSelectedValue(displayIntel,intelArray)
		viewIntel = intelArray[viewIntelPick]
		if(viewIntel=="Back")
			intelMenu = false
		else if(viewIntel=="Alien Fighter")
			intelShow("fighter")
		else if(viewIntel=="Alien Scout")
			intelShow("scout")
		else if(viewIntel=="Alien Bomber")
			intelShow("bomber")
		else if(viewIntel=="Alien Elite")
			intelShow("acefighter")
		else if(viewIntel=="Alien Mothership")
			intelShow("mothership")
	}
}

def extrasMenu = {
	def extrasArray = ["Watch Intro","View Intel","Help","Credits","Back"]
	def extrasLoop = true
	while(extrasLoop) {
		setImage("earthdefender/title.jpg")
		def extras = getSelectedValue("<b>EARTH DEFENDER</b>\n\nBy Banjo\n\n<i>"+version+"</i>\n\n"+helpmessage+"",extrasArray)
		def extrasPick = extrasArray[extras]
		if(extrasPick=="Back") {
			extrasLoop = false
		} else if(extrasPick=="View Intel") {
			intelView()
		} else if(extrasPick=="Help") {
			setImage("earthdefender/tutorial.png")
			show("<b>COMBAT PROCEDURE</b>\n\n1. Select the Quadrant of enemy approach (Alpha, Beta, Gamma, Delta).\n"+
				"* Guns will lock on and fire automatically.\n"+
				"* Hit chance depends on guns used and target Reaction Rating.\n"+
				"* You MUST select a Quadrant quickly, before the target moves away!\n\n"+
				"2. Instead of selecting a Quadrant, you can access the System Options.\n"+
				"* Charge Shields: restores +2 Shields (-1 Power).\n"+
				"* Switch Guns: switches between guns.\n"+
				">> Laser: more accurate, less damage.\n"+
				">> Machinegun: less accurate, more damage.\n"+
				"* Afterburner: makes you harder to hit for a short time (-1 Power).\n"+
				"* Launch Missile: auto-hits for big damage (-1 Missile).\n\n"+
				"IMPORTANT:\nIf your Shields are reduced to 0, your ship will be destroyed!")
			showButton("Back")
		} else if(extrasPick=="Credits") {
			show("WRITING:\n\nStory, Dialog & Characters:\nBanjo")
			showButton("Next")
			show("PROGRAMMING:\n\nScript Programming:\nBanjo\n\nTesting & Assistance:\nSexScripts Community\n\nSexScripts Engine:\nDoti")
			showButton("Next")
			show("GRAPHICS:\n\nAlien Ship Designs:\nSimon Schild (Simon-3D)\n\nShip HUD:\nBanjo, using Z-Design PS Brushes\n\n"+
				"Hanger Image:\nRichard Tilbury\n\nLasers, Blasts & Explosions:\nUfpelessar\nKepli\nLee Gainer\n\nBackgrounds:\nNASA\nVarious free online sources")
			showButton("Next")
			show("SOUND EFFECTS:\n\nOrigin\n(Wing Commander IV)\n\nBandai\n(Mobile Suit Gundam)")
			showButton("Next")
			show("MUSIC:\n\nKonami & Nazo Project\n(Gradius Perfect Selection)")
			showButton("Next")
			show("COPYRIGHT:\n\nThis SexScripts script is copyright Banjo 2016 and may not be sold or redistributed without permission.\n\n"+
				"All graphics, sounds and music used herein remain the property of their respective individual copyright holders.\n\n"+
				"Such material is used here in a not-for-profit manner. No challenge to existing copyrights intended.")
			showButton("Back to Menu")
		} else {
			show("Not available in demo")
			wait(2)
		}
	}
}

//Settings Menu
def settingsMenu = {
	loadSettings()
	fullhud = getBoolean("Enable full HUD?\n\nDisabling may increase game speed.\n\n(currently "+fullhud+")","True","False")
	if(fullhud)
		show("Full HUD enabled.")
	else
		show("Full HUD disabled.")
	wait(2)
	musicOn = getBoolean("Enable background music?\n\n(currently "+musicOn+")","True","False")
	if(musicOn) {
		playBackgroundSound(null)
		playMusic("01")
		show("Music enabled.")
	} else {
		playBackgroundSound(null)
		show("Music disabled.")
	}
	wait(2)
	debug = getBoolean("Enable debug mode?\n\n(currently "+debug+")","True","False")
	show("Debug set to "+debug+".")
	if(debug)
		show("Debug mode on.")
	else
		show("Debug mode off.")
	wait(2)
	show("Settings saved.")
	save("Banjo.earthdefender.fullhud",fullhud)
	save("Banjo.earthdefender.musicOn",musicOn)
	save("Banjo.earthdefender.debug",debug)
	save("Banjo.earthdefender.custom",true)
	wait(2)
}

//Main Menu
def mainMenu = {
	choiceArray = ["Arcade Mode","Story Mode","Extras","Settings","Quit"]
	quit = false
	menuMusic()
	while(!quit) {
		mode = "menu"
		setImage("earthdefender/title.jpg")
		choice = getSelectedValue("<b>EARTH DEFENDER</b>\n\nBy Banjo\n\n<i>"+version+"</i>\n\n"+helpmessage+"",choiceArray)
		choicePick = choiceArray[choice]
		if(choicePick=="Quit") {
			playBackgroundSound(null)
			show("Exiting...")
			wait(2)
			quit = true
		} else if(choicePick=="Arcade Mode") {
			playBackgroundSound(null)
//			pressStart()
			arcadeMode()
		} else if(choicePick=="Story Mode") {
//			playBackgroundSound(null)
			show("Not available in demo")
			wait(2)
		} else if(choicePick=="Extras") {
			extrasMenu()
		} else if(choicePick=="Settings") {
			settingsMenu()
		}
	}
}

//Install Check
def installed = loadBoolean("Banjo.spaceshooterpack.installed")
if(installed==null) {
	installed = false
	save("Banjo.spaceshooterpack.installed",installed)
}

def coreScript = new File("scripts/Banjo/spaceshooterpack.groovy")
if(coreScript.exists()) {
	installed = true
	save("Banjo.spaceshooterpack.installed",installed)
}
else {
	installed = false
	save("Banjo.spaceshooterpack.installed",installed)
}
if(!installed) {
	show(null)
	setImage(null)
	if(getBoolean("CORE FILES NOT FOUND!\n\n"
		+"This game requires the download of Banjo's 'Space Shooter Pack', containing teacher images, sounds and files."
		+"To download the needed files, simply go to the SexScripts website script database and search for 'Space Shooter Pack' (or the script tag 'earthdefender').\n\n"
		+"Alternately, you can visit the link below for links and more information:\n\n"
		+"http://ss.deviatenow.com/viewtopic.php?f=7&t=600\n\n"
		+"Apologies for the inconvenience!"
		+"", "Go to Webpage","Exit")) {
			if(isConnected()) {
				useUrl("http://ss.deviatenow.com/viewtopic.php?f=7&t=600")
				getString("Your internet browser should have opened the correct download page.\n\n"
					+"If not, please copy the link below and paste it into your web browser.", "http://ss.deviatenow.com/viewtopic.php?f=7&t=600")
			}
			else {
				getString("Cannot connect to the internet (your firewall may be blocking this operation)\n\n"
					+"Please copy the link below and paste it into your web browser.", "http://ss.deviatenow.com/viewtopic.php?f=7&t=600")
			}
		}
		show(null)
		setImage(null)
		if(loadBoolean("setting.newsetup")) {
			if(loadBoolean("setting.reload")) {
				return "system/welcome"
			}
			else {
				return "system/exit"
			}
		}
		else {
			return null
		}
}

//SCRIPT START
show(null)
setImage(null)
loadSettings()
mainMenu()
show(null)
setImage(null)
def quitGame = true
if(quitGame) {
	if(loadBoolean("setting.newsetup")) {
		if(loadBoolean("setting.reload")) {
			return "system/welcome"
		}
		else {
			return "system/exit"
		}
	}
	else {
		return null
	}
}

//SCRIPT END
